#ifdef GL_ES
    #define MED mediump
#else
    #define MED
#endif

attribute vec4 a_position;
attribute vec2 a_texCoord0;

uniform mat4 u_projTrans;
uniform vec2 u_dir;
uniform vec2 u_resolution;
uniform float u_strength;

varying MED vec2 v_texCoords0;
varying MED vec2 v_texCoords1;
varying MED vec2 v_texCoords2;
varying MED vec2 v_texCoords3;
varying MED vec2 v_texCoords4;

const vec2 futher = vec2(3.2307692308, 3.2307692308);
const vec2 closer = vec2(1.3846153846, 1.3846153846);

void main() {

    vec2 sizeAndDir = u_dir / u_resolution;
    vec2 f = futher * sizeAndDir * u_strength;
    vec2 c = closer * sizeAndDir * u_strength;

    v_texCoords0 = a_texCoord0 - f;
    v_texCoords1 = a_texCoord0 - c;
    v_texCoords2 = a_texCoord0;
    v_texCoords3 = a_texCoord0 + c;
    v_texCoords4 = a_texCoord0 + f;

    gl_Position = u_projTrans * a_position;
}