#ifdef GL_ES
    #define LOWP lowp
    precision mediump float;
#else
    #define LOWP
#endif

varying LOWP vec4 v_color;
varying vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec2 u_center;
uniform vec2 u_resolution;
uniform float u_progress;

void main() {

    //divide by 1000 to fix overflowing
    //use sqrt as length is not supported in GLES2

    float maxSize = max(u_resolution.x, u_resolution.y) / 1000.0;
    vec2 pos = (gl_FragCoord.xy - u_center.xy) / 1000.0;
    float len = sqrt(pos.x * pos.x + pos.y * pos.y);
    float radius = maxSize * u_progress;
    float width = maxSize / 20.0;

    vec2 uv = v_texCoords;
    vec4 c = texture2D(u_texture, uv);

    if(len > radius - width && len < radius + width * u_progress) {

        vec2 dir = normalize(u_center.xy - gl_FragCoord.xy) * (u_progress * 8.0);

        uv.x += dir.x * 0.01;
        uv.y += dir.y * 0.01;

        c = texture2D(u_texture, uv);
        c.a = 1.0 - u_progress;

        float color = u_progress * 0.15;
        c.rgb += color;
    }

    gl_FragColor = c;
}